

//pull the byte array
//convert to a string
//ignore idential strings
//make audio database
//crosscheck string and database

import processing.serial.*; //load external library for serial control
import ddf.minim.*; 

Minim minim;
AudioPlayer player;

Serial myPort;    // The serial port
PFont myFont;     // The display font
String inString;  // Input string from serial port
int charcount; //
int eol = 45;      //end of line ASCII code for end of string symbol '-'
String lastword = "";

StringList dictionary;
String validWords[];

void setup() {
  size(400,200);
  background(0);
  minim = new Minim(this);
  myFont = loadFont("ArialMT-18.vlw");
  textFont(myFont, 18);
  
  // List all connected serial ports:
  println(Serial.list());
  myPort = new Serial(this, Serial.list()[1], 9600); //create serial device on the 2nd port avaliable
  myPort.bufferUntil(eol); //buffer the serial line until the line end character is read. '-'
  loadDictionary();
}

void loadDictionary() {
  dictionary = new StringList();
  validWords = loadStrings("wordlist.txt");
  for(int x = 0; x < validWords.length; x++){
    dictionary.append(validWords[x]);
  }
  println(dictionary);
  dictionary.shuffle();
  println(dictionary);
  

}

int wordLookup(String currentBlocks){
  /*checks to see if the String passed to this function is in our dictionary of words,
  if it the DO SOMETHING TO TRIGGER THE SOUND AND UPDATE THIS COMMENT.
  if not check to see if the string has the potential to be a word in our dictionary,
  if so DO SOMETING TO SOUND OUT HE LETTERS AND UPDATE THIS COMMENT.*/
  //return 0 if invalid, 2 for a valid word, and 1 for a partial word.
  dictionary.shuffle(); //have abit of a shffule, might help with lag???
    if(dictionary.hasValue(currentBlocks) == true){
      println(currentBlocks + " is a word");
      return 2;
  } else {
    for(int x = 0; x < dictionary.size(); x++){
      String scanning = dictionary.get(x);
      if(scanning.indexOf(currentBlocks) == 0){
        println("found in " + dictionary.get(x));
        return 1;
      } else {
        println("not in dictionary[" + x + "]");
      }
    }
    return 0;
  }
}

void draw() {
  
  inString = readSerial();
  
  if(inString.length() > 12){ //why 12? wish id commented this
    
    inString = inString.substring(0, inString.indexOf(eol)); //remove the end of line char from the string
    if(lastword.equals(inString) == false){
      switch (wordLookup(inString)) {
        case 0:
        //do nothing
        break;
        case 1:
        drawBlocks(inString.length(), inString);
        soundItOut(inString);
        break;
        case 2:
        drawBlocks(inString.length(), inString);
        println(">"+inString+"<");
        //String playword = 
      player = minim.loadFile("words/"+inString + ".mp3");
      
      player.play();
        break;
      }
    }
    lastword = inString;
  }
}

void soundItOut(String letters){

    for(int i = 0; i < letters.length()-1; i ++){
      player = minim.loadFile("letters/" + letters.charAt(i) + ".mp3");
      player.play();
      while(player.isPlaying() == true){
        //wait
      }
    }
}

void drawBlocks(int blockCount, String word){
  background(0);
  int blockSize = 200/blockCount;
  if(blockSize > 150){blockSize = 150;}
  for(int i = 0; i < word.length(); i ++){
    stroke(0, 50, 100);
    fill(200, 200, 200);
    rect(blockSize*(i+1),50,blockSize,blockSize,3);
    fill(0, 102, 153);
    text(word.charAt(i), (blockSize*(i+1))+(blockSize/2), 50+(blockSize/2));
    
  }
  
}

String readSerial() {
  String output = "";
    while (myPort.available() > 0) {
    // Expand array size to the number of bytes you expect:
    byte[] inBuffer = new byte[15];
    myPort.readBytesUntil(eol, inBuffer);
    if (inBuffer != null) {
      String myString = new String(inBuffer);
      //inString = myString;
      //int empty = myString.indexOf('-');
     // inString = myString.substring(0, empty);
     // inString = myString;
     // print(empty);
      //println(inString);
      output = myString;
    } 
  }
  return output;
  
}

